/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.cg;

import java.io.File;

import junit.framework.TestCase;
import blanco.cg.transformer.BlancoCgTransformerFactory;
import blanco.cg.valueobject.BlancoCgClass;
import blanco.cg.valueobject.BlancoCgEnum;
import blanco.cg.valueobject.BlancoCgEnumElement;
import blanco.cg.valueobject.BlancoCgField;
import blanco.cg.valueobject.BlancoCgInterface;
import blanco.cg.valueobject.BlancoCgMethod;
import blanco.cg.valueobject.BlancoCgSourceFile;

/**
 * Delphip̐B
 * 
 * @author YAMAMOTO Koji
 */
public class BlancoCgTransformerDelphiTest extends TestCase {
    /**
     * Delphi̎B
     * 
     * @throws Exception
     */
    public void testTransformerDelphi() throws Exception {
        final BlancoCgObjectFactory cgFactory = BlancoCgObjectFactory
                .getInstance();

        // \[Xt@C𐶐܂B

        final BlancoCgSourceFile cgSourceFile = cgFactory.createSourceFile(
                "Unit1", "eXgp̃NX");
        cgSourceFile.setName("Unit1");

        cgSourceFile.getImportList().add("System.Text.DummyText");
        // pbP[W̃C|[gB
        cgSourceFile.getImportList().add("Myprog.MyClass2");

        // NX𐶐܂B
        final BlancoCgClass cgClass = cgFactory.createClass("TMyClass",
                "̃NX́AeXĝ߂̃NXłB");
        cgSourceFile.getClassList().add(cgClass);
        // cgClass.getLangDoc().getTagList().add(
        // cgFactory.createLangDocTag("author", null, "blanco Framework"));
        cgClass.getExtendClassList().add(cgFactory.createType("TObject"));
        // cgClass.getImplementInterfaceList().add(
        // cgFactory.createType("System.WebException"));
        // cgClass.getImplementInterfaceList().add(
        // cgFactory.createType("System.WebException2"));

        // 񋓑
        // final BlancoCgEnum cgEnum = cgFactory.createEnum("FavorColor",
        // "񋓑̂̎B");
        // cgClass.getEnumList().add(cgEnum);
        // final BlancoCgEnumElement cgEnumElementFirst = cgFactory
        // .createEnumElement("Red", "");
        // cgEnumElementFirst.setDefault("1");
        // cgEnum.getElementList().add(cgEnumElementFirst);
        // cgEnum.getElementList().add(
        // cgFactory.createEnumElement("Yerrow", ""));
        // cgEnum.getElementList().add(cgFactory.createEnumElement("Blue",
        // ""));

        // tB[h𐶐܂B
        final BlancoCgField cgField = cgFactory.createField("MyField",
                "String", "StringtB[h̎łB");
        cgClass.getFieldList().add(cgField);
        // cgField.setDefault("new DateTime()");
        //
        // final BlancoCgField cgField2 = cgFactory.createField("myField2",
        // "java.util.Date", "ttB[h̎v2łB");
        // cgClass.getFieldList().add(cgField2);
        // cgField2.getType().setArray(true);

        // vV[W𐶐܂B
        final BlancoCgMethod cgMethod = cgFactory.createMethod("MyMethod",
                "vV[W̎łB");
        cgClass.getMethodList().add(cgMethod);

        // p[^ǉ܂B
        cgMethod.getParameterList().add(
                cgFactory.createParameter("argString", "String", "B"));
        cgMethod.getParameterList().add(
                cgFactory.createParameter("argInt", "integer", "B"));

        // t@NV𐶐܂B
        final BlancoCgMethod cgFunction = cgFactory.createMethod("MyFunction",
                "\bh̎łB");
        cgClass.getMethodList().add(cgFunction);

        // p[^ǉ܂B
        cgFunction.getParameterList().add(
                cgFactory.createParameter("argString", "String", "B"));
        cgFunction.getParameterList().add(
                cgFactory.createParameter("argInt", "integer", "B"));

        // ߂lݒ肵܂B
        cgFunction.setReturn(cgFactory.createReturn("boolean", "ȂtrueB"));

        // cgMethod.getThrowList().add(
        // cgFactory.createException("System.IO.IOException",
        // "o͗OꍇB"));

        // Ame[V̒ǉB
        // cgMethod.getAnnotationList().add(
        // "Copyright(value=\"blanco Framework\")");

        // \bh̓eǉ܂B
        // cgMethod.getLineList().add("// ̎łB");
        // cgMethod.getLineList().add("int a = 0;");

        final BlancoCgTransformer cgTransformerDelphi = BlancoCgTransformerFactory
                .getDelphiSourceTransformer();
        cgTransformerDelphi.transform(cgSourceFile, new File("./tmp/blanco"));
    }

}
